window.onload = function() {
	var keyword = getParameterFromURL("subject"); // obtain keyword from the URL "?subject="
	var list = ""; // list to be displayed
	var ruteToHitPoint = "";
	var prefs = new Array();
	// Work loop
	$.each(LinkData.getWorks(), function(workKey, workValue) {
		list += "<h3>" + LinkData.getWorkName(workValue) + "</h3>";
		// File loop
		$.each(LinkData.getFiles(workValue), function(fileKey, fileValue) {
			var hit = ""; // list of subjects whose URI matches keyword
			var nHit = 0; // number of subjects whose URI matches keyword
			// Subject loop
			$.each(LinkData.getSubjects(workValue, fileValue), function(subjKey, subjValue) {
				var longitude = null;
				var latitude = null;
				var s = ""; // subject to be displayed
//				s += "<a href=\"" + subjValue + "\" target=\"_top\"><span class=\"subject\">" + highlight(decodeURIComponent(subjValue), keyword) + "</span></a>";
				$.each( LinkData.getTriplesBySubject(workValue, fileValue, subjValue), function( tripleKey, tripleValue ) {
					var prop = tripleValue.property;
					var obj = tripleValue.object;
					if ( prop == "http://www.w3.org/2003/01/geo/wgs84_pos#long" ) longitude = obj;// longitude found
					if ( prop == "http://www.w3.org/2003/01/geo/wgs84_pos#lat" ) latitude = obj;// latitude found
					if ( obj.indexOf("://www.youtube.com") != -1 && obj.indexOf("v=") != -1 ) { // Insert YouTube Thumbnail
						videoId = (obj.split("v=")[1]).split("&")[0]; // get video id
						obj = "<a href=\"" + obj + "\" target=\"_blank\"><span class=\"object\">" + highlight(decodeURIComponent(obj), keyword) + "<br><img src=\"http://img.youtube.com/vi/" + videoId + "/mqdefault.jpg\" alt=\"YouTube video\" /><br></span></a>";
						}
						else if ( obj.indexOf("http") == 0 ) {
							if ((obj.indexOf(".jpg" )>0 || obj.indexOf(".gif" )>0 || obj.indexOf(".png" )>0) || (obj.indexOf(".JPG" )>0 || obj.indexOf(".GIF" )>0 || obj.indexOf(".PNG" )>0)) // insert image
								 obj = "<a href=\"" + obj + "\" target=\"_blank\"><span class=\"object\">" +shortenURL(obj) + "<br><img src=\"" + obj + "\" alt=\"image\" /><br></span></a>";
							else
								obj = "<a href=\"" + obj + "\" target=\"_blank\"><span class=\"object\">" + shortenURL(obj) + "</span></a>"; // Make it clicable if it starts from http
					}
					else
						obj = "<span class=\"object\">" + highlight(obj, keyword) + "</span>";
					s += "<br><span class=\"propertyName\">" + getLastName(prop) + ":\t</span>" +  obj;
				});
				if ( latitude != null && longitude != null ) s += addLinkToMap( latitude, longitude );
//				list += s; //add to the list to be displayed
				prefs.push(["<hr>"+s,latitude,longitude]);
				if ( decodeURIComponent(subjValue) == keyword ) { // found subject whose URI matches keyword
					hit += s;
					ruteToHitPoint = "http://www.google.com/maps/?daddr=" + latitude + "," + longitude;
					nHit++;
				}
				//link to map display if coordinates exist
			});
			if ( nHit > 0 ) {
				list += "<hr><h4>"+nHit+" subjects matched to the query</h4>";
				list += hit + "<br><br>";
			}
		});
	});
	$("#result").append( list + "Please try again after allowing this device to access the geo positional information" );

  	navigator.geolocation.getCurrentPosition(function(pos) {
    	var lat = pos.coords.latitude;
    	var long = pos.coords.longitude;
		if ( ruteToHitPoint != "" )
		{
			$('#result').empty();
			$('#result').append( list + "<hr><h4>Now displaying the route from here to the destination.</h4>");
			parent.location.href = ruteToHitPoint + "&saddr=" + lat + "," + long; // redirecting
		}
		else
		{
			$('#result').empty();
			$('#result').append( list + "<hr><h4>Now displaying the list in the order from close location</h4>");
    		$.each(prefs, function(i, p) {
      			p[3] = (lat - p[1]) * (lat - p[1]) + (long - p[2]) * (long - p[2]);
    		});
    		prefs.sort(function(p1, p2) {
      			return p1[3] - p2[3];
    		});
	   		$.each(prefs, function(i, p) {
      			$('#result').append(p[0]);
     			$('#result').append("　<a target=\"_top\" href=\"http://www.google.com/maps/?saddr=" + lat + "," + long + "&daddr=" + p[1] + "," + p[2] + "\">【Show route from here to the destination】</a>");
			});
		}
	}, function(error) {
		$('#result').empty();
		$('#result').append( list + "<hr><h4>Now showing the list in the original order, due to the faiure to obtain the current position of this device.</h4>");
	   	$.each(prefs, function(i, p) {
      		$('#result').append(p[0]);
		});
	});
};

// Get a parameter value in URL (e.g. ?paramString=value )
function getParameterFromURL( paramString )
{			
	var value = "";
	var topWindow = top.window.location.search;
	if( topWindow ){
		var q = decodeURIComponent(topWindow.substring(1,topWindow.length)).split("&");
		for ( var i = 0; i < q.length; i++ ){
			var r = q[i].split("=");
			if ( r[0] ==  paramString )
				value = r[1];
		}
	}
 	return value;
}

// Highlight keyword in the string
function highlight( string, keyword )
{
	if ( keyword.length > 0 ) {
		var ss = string.split(keyword);
		var len = ss.length;
		if ( len > 1 ) {
			string = ss[0];
			for ( i = 1; i < len; i++ )
//				string += "<font color=\"red\">"+keyword+"</font>"+ss[i];
				string += "<span class=\"highlight\">"+keyword+"</span>"+ss[i];
		}
	}
	return string;
}

// get the last name of the string separated with # and /
function getLastName( string )
{
	string = decodeURIComponent(string);
	var sharp = string.split("#");
	var slash = sharp[sharp.length-1].split("/");
	var lastName = slash[slash.length-1];
	return lastName;
}

// return a link to Google map search
function addLinkToMap( latitude, longitude )
{
	var s = "<br><a target=\"_top\" href=\"http://www.google.com/maps/?q=" + latitude + "," + longitude + "\">【Show map】</a>";
	return s;
}

// shortening URL e.g. http://.../123.jpg
function shortenURL( url )
{
	url = decodeURIComponent(url);
	var slash = url.split("/");
	var lastName = slash[slash.length-1];
	return url.split(":")[0]+"://.../"+lastName;
}
